#include <windows.h>
#include <shlobj.h>
#include <muroar.h>
#include <stdio.h>
#include <stdlib.h>

#include "winamp/out.h"

#define PI_VER2 "v0.01 alpha"

#ifdef __alpha
	#define PI_VER PI_VER2 " (AXP)"
#else
	#define PI_VER PI_VER2 " (x86)"
#endif

int out_roard_getwrittentime();
int out_roard_getoutputtime();
void remove_unwanted_chars (char *str);
void get_server_name (char *str);

static int srate, numchan, bps, active;
volatile int writtentime, w_offset;
static int streamfh;
static int streamid;

BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

Out_Module out;

static int last_pause=0;

void out_roard_config(HWND hwndParent)
{
	
	//MessageBox(hwndParent, "No configuration.", "Configuration RoarAudio Output", MB_OK);
	//char buf[300] = {0};
	//InputBox("Configuration RoarAudio Output", "Please enter the Serveraddress to which we should stream:", buf, 300, false);
	// if we had a configuration box we'd want to write it here (using DialogBox, etc)
}

void out_roard_about(HWND hwndParent)
{
	MessageBox(hwndParent, "RoarAudio output plugin, by Stephan Jauernick", "About RoarAudio Output",MB_OK);
}

void out_roard_init()
{
//TODO: IMPLANT THAT
}

void out_roard_quit()
{
//TODO: IMPLANT THAT
}

int start_t;

int out_roard_open(int samplerate, int numchannels, int bitspersamp, int bufferlenms, int prebufferms)
{
	start_t=GetTickCount();
 	w_offset = writtentime = 0;
	active=1;
	numchan = numchannels;
	srate = samplerate;
	bps = bitspersamp;
	
	char server[80];
	get_server_name(server);
	
	if ( (streamfh = muroar_connect(server, "WinAmp")) == -1 )
		return -1;
		
	if ( muroar_stream(streamfh, MUROAR_PLAY_WAVE, &streamid, MUROAR_CODEC_PCM, samplerate, numchannels, bitspersamp) == -1 )
		return -1;
		
	return 0;
}

void out_roard_close()
{
	muroar_close(streamfh);
}

int out_roard_write(char *buf, int len)
{
	writtentime += len;

	muroar_write(streamfh, buf, len );

	return 0;
}

int out_roard_canwrite()
{
	if (last_pause) return 0;
	if (out_roard_getwrittentime() < out_roard_getoutputtime()+MulDiv(65536,1000,srate*bps*numchan/8)) return 65536;
	return 0;
}

int out_roard_isplaying()
{
	return 0;
}

int out_roard_pause(int pause)
{
	int t=last_pause;
	if (!last_pause && pause) { w_offset+=GetTickCount()-start_t;  writtentime=0; }
	if (last_pause && !pause) { start_t=GetTickCount(); }
	last_pause=pause;
	return t;
}

void out_roard_setvolume(int volume)
{
//TODO: IMPLANT THAT
}

void out_roard_setpan(int pan)
{
//TODO: IMPLANT THAT
}

void out_roard_flush(int t)
{
	w_offset=t;
	start_t=GetTickCount();
	writtentime=0;

}
	
int out_roard_getoutputtime()
{
	if (last_pause)
		return w_offset;
	return GetTickCount()-start_t + w_offset;
}

int out_roard_getwrittentime()
{
	int t=srate*numchan,l;
	int ms=writtentime;

	if (t)
	{
		l=ms%t;
		ms /= t;
		ms *= 1000;
		ms += (l*1000)/t;

		ms/=(bps/8);

		return ms + w_offset;
	}
	else
		return ms;
}

Out_Module out = {
	OUT_VER,
	"RoarAudio Output Plugin " PI_VER,
	70000,
	0, // hmainwindow
	0, // hdllinstance
	out_roard_config,
	out_roard_about,
	out_roard_init,
	out_roard_quit,
	out_roard_open,
	out_roard_close,
	out_roard_write,
	out_roard_canwrite,
	out_roard_isplaying,
	out_roard_pause,
	out_roard_setvolume,
	out_roard_setpan,
	out_roard_flush,
	out_roard_getoutputtime,
	out_roard_getwrittentime
};

__declspec( dllexport ) Out_Module * winampGetOutModule()
{
	return &out;
}

void get_server_name (char *str)
{
	FILE *fp;
	char line[80];
	
	if((fp = fopen("c:\\out_roar.conf", "r"))==NULL) {
		printf("Cannot open file.\n");
		exit(1);
	}

	//Get the first line and check if file is empty.
	if(fgets(line,80,fp) == NULL)
    {
		printf("Your file seems to be empty!");
		exit(1);
	}

	//Get rid of a eventuall newline
	remove_unwanted_chars(line);
	
	if(fclose(fp))
	{
		printf("Somehow our close on the file failed!");
		exit(1);
	}
	strcpy(str,line);
}

void remove_unwanted_chars(char *str)
{
	int i=0;
	int i_new=0;
	int got_char = 0;
	char str_new[80];
	for(i;str[i]!=0;i++)
	{
		if (isspace(str[i]) && !got_char) 
		{
			continue;
		}
		
		if(isspace(str[i]) && got_char)
		{
			str_new[i_new] = '\0';
			break;
		}
		
		if(isalnum(str[i]) || ispunct(str[i]) || str[i] == ':')
		{
			str_new[i_new]=str[i];
			i_new++;
#ifdef DEBUG
			printf("test: i_new:%d i:%d str:%c str_new:%c\n",i_new, i,str[i],str_new[i_new]);
#endif
			got_char = 1;
			continue; 
		}
	}
#ifdef DEBUG
	printf("str_new(%d): %s\n",strlen(str_new),str_new);
	printf("str(%d): %s\n",strlen(str),str);
#endif	
	str_new[i_new] = '\0';
	strncpy(str,str_new, strlen(str_new));
	str[i_new] = '\0';
	
}
